var fs         = require('fs'),
    path       = require('path');

module.exports = {
    // Runs up the directory chain looking for a .cordova directory.
    // IF it is found we are in a Cordova project.
    // If not.. we're not.
    isCordova: function isCordova(dir) {
        if (dir) {
            var contents = fs.readdirSync(dir);
            if (contents && contents.length && (contents.indexOf('.cordova') > -1)) {
                return dir;
            } else {
                var parent = path.join(dir, '..');
                if (parent && parent.length > 1) {
                    return isCordova(parent);
                } else return false;
            }
        } else return false;
    },
    // Determines whether the library has a copy of the specified
    // Cordova implementation
    havePlatformLib: function havePlatformLib(platform) {
        var dir = path.join(__dirname, '..', 'lib', platform);
        try {
            fs.lstatSync(dir);
            // Have it!
            return true;
        } catch(e) {
            // Don't have it.
            return false;
        }
    }
};
